
;include matrix16f.inc

fObject struct
	lpName	dword 0
	nChannel dword 0
	OffsetX dword 0
	OffsetY dword 0
	OffsetZ dword 0
	PositionX dword 0
	PositionY dword 0
	PositionZ dword 0
	RotationX dword 0
	RotationY dword 0
	RotationZ dword 0
	lpRotationMatrix	dword 0
	lpChannel1	dword 0
	lpChannel2	dword 0
	lpChannel3	dword 0
	lpChannel4	dword 0
	lpChannel5	dword 0
	lpChannel6	dword 0
	nParent dword 0
fObject ends

fBVHObject struct
	nObjCount	dword 0
	lpData		dword 0
fBVHObject ends

fBVH struct
	nFrameCount dword 0
	flFrameTime	dword 0
	nObjCount	dword 0
	lpData		dword 0
	cFrame		dword 0
fBVH ends

.code

fRotateMatrix proc uses esi edi lpmatrix:dword,distX:dword,distY:dword,distZ:dword,rotX:dword,rotY:dword,rotZ:dword
	
	invoke glPushMatrix
		invoke glLoadIdentity
		invoke glRotatef,rotX,FP4(1.0),FP4(0.0),FP4(0.0)
		invoke glRotatef,rotY,FP4(0.0),FP4(1.0),FP4(0.0)
		invoke glRotatef,rotZ,FP4(0.0),FP4(0.0),FP4(1.0)
		invoke glTranslatef,distX,distY,distZ
		invoke glGetFloatv,GL_MODELVIEW_MATRIX,lpmatrix
	invoke glPopMatrix
	
	ret
fRotateMatrix endp

fBVHGetDataS proc uses esi edi lpStruct:dword,nFrame:dword,nObj:dword
	
	mov esi,lpStruct
	mov esi,[esi].fBVH.lpData
	mov ecx,nFrame
	mov eax,[esi+ecx*4]
	mov ecx,nObj
	mov eax,[eax+ecx*4]
	
	ret
fBVHGetDataS endp

fRotateVector proc lpmatrix:dword,rotX:real4,rotY:real4,rotZ:real4
	invoke glPushMatrix
		invoke glLoadIdentity
		invoke glRotatef,rotX,FP4(1.0),FP4(0.0),FP4(0.0)
		invoke glRotatef,rotY,FP4(0.0),FP4(1.0),FP4(0.0)
		invoke glRotatef,rotZ,FP4(0.0),FP4(0.0),FP4(1.0)
		invoke glGetFloatv,GL_MODELVIEW_MATRIX,lpmatrix
	invoke glPopMatrix
	
	
	ret
fRotateVector endp

fMulVextor proc uses esi edi lpm16f:dword,lpfobject:dword
	
	mov edi,lpm16f
	mov esi,lpfobject
	
	fld dword ptr [edi+0*4]
	fmul [esi].fObject.OffsetX
	fstp [esi].fObject.PositionX
	fld dword ptr [edi+1*4]
	fmul [esi].fObject.OffsetY
	fadd [esi].fObject.PositionX
	fstp [esi].fObject.PositionX
	fld dword ptr [edi+2*4]
	fmul [esi].fObject.OffsetZ
	fadd [esi].fObject.PositionX
	fstp [esi].fObject.PositionX
	
	fld dword ptr [edi+4*4]
	fmul [esi].fObject.OffsetX
	fstp [esi].fObject.PositionY
	fld dword ptr [edi+5*4]
	fmul [esi].fObject.OffsetY
	fadd [esi].fObject.PositionY
	fstp [esi].fObject.PositionY
	fld dword ptr [edi+6*4]
	fmul [esi].fObject.OffsetZ
	fadd [esi].fObject.PositionY
	fstp [esi].fObject.PositionY
	
	fld dword ptr [edi+8*4]
	fmul [esi].fObject.OffsetX
	fstp [esi].fObject.PositionZ
	fld dword ptr [edi+9*4]
	fmul [esi].fObject.OffsetY
	fadd [esi].fObject.PositionZ
	fstp [esi].fObject.PositionZ
	fld dword ptr [edi+10*4]
	fmul [esi].fObject.OffsetZ
	fadd [esi].fObject.PositionZ
	fstp [esi].fObject.PositionZ
	
	
	ret
fMulVextor endp

fBVHDrawLine proc uses esi edi lpStruct:dword,nFrame:dword
	LOCAL _cx:dword
	LOCAL curr_data,prnt_data:dword
	LOCAL x[16]:dword
	
	mov esi,lpStruct
	xor ecx,ecx
	loop_d:
	push ecx
		invoke fBVHGetDataS,esi,nFrame,ecx
		mov curr_data,eax
		invoke fBVHGetDataS,esi,nFrame,[eax].fObject.nParent
		mov prnt_data,eax
		
		
		mov ecx,prnt_data
		invoke fRotateVector,addr x,[ecx].fObject.RotationX,[ecx].fObject.RotationY,[ecx].fObject.RotationZ
		mov edx,curr_data
		invoke fMulVextor,addr x,curr_data
		
		invoke glBegin,GL_LINES
		mov eax,prnt_data
		invoke glVertex3f,[eax].fObject.OffsetX,[eax].fObject.OffsetY,[eax].fObject.OffsetZ
		mov eax,curr_data
		invoke glVertex3f,[eax].fObject.OffsetX,[eax].fObject.OffsetY,[eax].fObject.OffsetZ
		invoke glEnd
		
		jmp @F
		mov ecx,[esp]
		.if ecx==1	
			invoke glBegin,GL_LINES
			mov eax,prnt_data
			invoke glVertex3f,[eax].fObject.OffsetX,[eax].fObject.OffsetY,[eax].fObject.OffsetZ
			mov eax,curr_data
			invoke glVertex3f,[eax].fObject.PositionX,[eax].fObject.PositionY,[eax].fObject.PositionZ
			invoke glEnd
		.else
			invoke glBegin,GL_LINES
			mov eax,prnt_data
			invoke glVertex3f,[eax].fObject.PositionX,[eax].fObject.PositionY,[eax].fObject.PositionZ
			mov eax,curr_data
			invoke glVertex3f,[eax].fObject.PositionX,[eax].fObject.PositionY,[eax].fObject.PositionZ
			invoke glEnd
		.endif
		@@:
	pop ecx
	inc ecx
	cmp ecx,[esi].fBVH.nObjCount
	jl loop_d
	
	ret
fBVHDrawLine endp

;Internal use

fBVHGetData proc uses esi edi lpFrame:dword,nFrame:dword,nObj:dword
	
	mov esi,lpFrame
	mov ecx,nFrame
	mov eax,[esi+ecx*4]
	mov ecx,nObj
	mov eax,[eax+ecx*4]
	
	ret
fBVHGetData endp

fBVHSetData proc uses esi edi lpFrame:dword,nFrame:dword,nObj:dword,data:Dword
	
	mov esi,lpFrame
	mov ecx,nFrame
	mov eax,[esi+ecx*4]
	mov ecx,nObj
	mov edx,data
	mov [eax+ecx*4],edx
	
	ret
fBVHSetData endp

fBVHFillStructName6 proc uses esi edi hFile:dword,indexFile:dword,lpFrame:dword,indexFrame:dword
	LOCAL buff [1024]:dword
	LOCAL pmem:dword
	
	invoke GetWord,hFile,indexFile,3
	push edx
	invoke mAlloc,[edx].frbWordStruct.nSize
	mov pmem,eax
	pop edx
	mov ecx,[edx].frbWordStruct.nSize
	inc ecx
	invoke lstrcpyn,pmem,[edx].frbWordStruct.lpAddress,ecx	
	invoke fBVHGetData,lpFrame,0,indexFrame
	push pmem
	pop [eax].fObject.lpChannel1

	invoke GetWord,hFile,indexFile,4
	push edx
	invoke mAlloc,[edx].frbWordStruct.nSize
	mov pmem,eax
	pop edx
	mov ecx,[edx].frbWordStruct.nSize
	inc ecx
	invoke lstrcpyn,pmem,[edx].frbWordStruct.lpAddress,ecx	
	invoke fBVHGetData,lpFrame,0,indexFrame
	push pmem
	pop [eax].fObject.lpChannel2
	
	invoke GetWord,hFile,indexFile,5
	push edx
	invoke mAlloc,[edx].frbWordStruct.nSize
	mov pmem,eax
	pop edx
	mov ecx,[edx].frbWordStruct.nSize
	inc ecx
	invoke lstrcpyn,pmem,[edx].frbWordStruct.lpAddress,ecx	
	invoke fBVHGetData,lpFrame,0,indexFrame
	push pmem
	pop [eax].fObject.lpChannel3


	invoke GetWord,hFile,indexFile,6
	push edx
	invoke mAlloc,[edx].frbWordStruct.nSize
	mov pmem,eax
	pop edx
	mov ecx,[edx].frbWordStruct.nSize
	inc ecx
	invoke lstrcpyn,pmem,[edx].frbWordStruct.lpAddress,ecx	
	invoke fBVHGetData,lpFrame,0,indexFrame
	push pmem
	pop [eax].fObject.lpChannel4

	
	invoke GetWord,hFile,indexFile,7
	push edx
	invoke mAlloc,[edx].frbWordStruct.nSize
	mov pmem,eax
	pop edx
	mov ecx,[edx].frbWordStruct.nSize
	inc ecx
	invoke lstrcpyn,pmem,[edx].frbWordStruct.lpAddress,ecx	
	invoke fBVHGetData,lpFrame,0,indexFrame
	push pmem
	pop [eax].fObject.lpChannel5

	invoke GetWord,hFile,indexFile,8
	push edx
	invoke mAlloc,[edx].frbWordStruct.nSize
	mov pmem,eax
	pop edx
	mov ecx,[edx].frbWordStruct.nSize
	inc ecx
	invoke lstrcpyn,pmem,[edx].frbWordStruct.lpAddress,ecx	
	invoke fBVHGetData,lpFrame,0,indexFrame
	push pmem
	pop [eax].fObject.lpChannel6
	
	ret
fBVHFillStructName6 endp

fBVHFillStructName3 proc uses esi edi hFile:dword,indexFile:dword,lpFrame:dword,indexFrame:dword
	LOCAL buff [1024]:dword
	LOCAL pmem:dword
	
	invoke GetWord,hFile,indexFile,3
	push edx
	invoke mAlloc,[edx].frbWordStruct.nSize
	mov pmem,eax
	pop edx
	mov ecx,[edx].frbWordStruct.nSize
	inc ecx
	invoke lstrcpyn,pmem,[edx].frbWordStruct.lpAddress,ecx	
	invoke fBVHGetData,lpFrame,0,indexFrame
	push pmem
	pop [eax].fObject.lpChannel1

	invoke GetWord,hFile,indexFile,4
	push edx
	invoke mAlloc,[edx].frbWordStruct.nSize
	mov pmem,eax
	pop edx
	mov ecx,[edx].frbWordStruct.nSize
	inc ecx
	invoke lstrcpyn,pmem,[edx].frbWordStruct.lpAddress,ecx	
	invoke fBVHGetData,lpFrame,0,indexFrame
	push pmem
	pop [eax].fObject.lpChannel2
	
	invoke GetWord,hFile,indexFile,5
	push edx
	invoke mAlloc,[edx].frbWordStruct.nSize
	mov pmem,eax
	pop edx
	mov ecx,[edx].frbWordStruct.nSize
	inc ecx
	invoke lstrcpyn,pmem,[edx].frbWordStruct.lpAddress,ecx	
	invoke fBVHGetData,lpFrame,0,indexFrame
	push pmem
	pop [eax].fObject.lpChannel3
	
	ret
fBVHFillStructName3 endp

fBVHLoadValue proc uses esi edi lIne:dword,lpTheAddress:dword,lpQword:dword
	LOCAL fr:qword
	
	mov eax,lpQword
	fld qword ptr[eax]
	fstp fr
	
	mov edx,lIne
	mov eax,lpTheAddress
	.if dx=="pX"
		fld fr
		fstp [eax].fObject.PositionX
	.elseif dx=="pY"
		fld fr
		fstp [eax].fObject.PositionY
	.elseif dx=="pZ"
		fld fr
		fstp [eax].fObject.PositionZ
	.elseif dx=="rX"
		fld fr
		fstp [eax].fObject.RotationX
	.elseif dx=="rY"
		fld fr
		fstp [eax].fObject.RotationY
	.elseif dx=="rZ"
		fld fr
		fstp [eax].fObject.RotationZ
	.endif
	
	ret
fBVHLoadValue endp
; end of internal use

fBVHReadData proc uses esi edi lpFileName:dword,lpfBVH:dword
	LOCAL hFile:dword
	LOCAL joint,hip:dword
	LOCAL counter,w_cnt,node_cnt:dword
	LOCAL buff[256]:dword
	LOCAL lpframe,lpnode,frame_cnt,l_cnt,offset_cnt,data_off,obj_data,channel_cnt,fl,fd:dword
	LOCAL fr:qword
	LOCAL fr_time:qword
	LOCAL m_data,t_data,a_data,channel_c:dword
	LOCAL node_st,nodest_cnt:dword
	
	; frame->object->+0 Rotation data +4 Position data +8 Offset data
	
	invoke OpenFileFrb,lpFileName
	.if eax==-1
		invoke MessageBox,0,CADD("File Open Error"),0,0
		ret
	.endif
	mov hFile,eax
	
	invoke UMLineCount,hFile
	mov counter,eax
	xor ecx,ecx
	mov node_cnt,ecx
	loop_each_lines:
		pushad
			inc ecx
			invoke UM_Word_Count,hFile,ecx
			mov w_cnt,eax
		popad
		cmp w_cnt,0
		jz end_check
		cmp w_cnt,-1
		jz end_check
		pushad
			invoke memfill,addr buff,1024,0
		popad
		pushad
			inc ecx
			mov l_cnt,ecx
			invoke GetWord,hFile,ecx,1
			pushad
				mov ecx,[edx].frbWordStruct.nSize
				inc ecx
				invoke lstrcpyn,addr buff,[edx].frbWordStruct.lpAddress,ecx
				invoke szCmpi,addr buff,CADD("ROOT"),4
				.if eax==0
					inc node_cnt
					;invoke MessageBox,0,0,0,0
				.endif
			popad
			pushad
				mov ecx,[edx].frbWordStruct.nSize
				inc ecx
				invoke lstrcpyn,addr buff,[edx].frbWordStruct.lpAddress,ecx
				invoke szCmpi,addr buff,CADD("JOINT"),5
				.if eax==0
					inc node_cnt
					;invoke MessageBox,0,0,0,0
				.endif
			popad
			pushad
				mov ecx,[edx].frbWordStruct.nSize
				inc ecx
				invoke lstrcpyn,addr buff,[edx].frbWordStruct.lpAddress,ecx
				invoke szCmpi,addr buff,CADD("END"),3
				.if eax==0
					inc node_cnt
					;invoke MessageBox,0,0,0,0
				.endif
			popad
			pushad
				invoke szCmpi,addr buff,CADD("FRAMES"),6
				.if eax==0
					invoke GetWord,hFile,l_cnt,2
					.if eax!=-1
						mov ecx,[edx].frbWordStruct.nSize
						inc ecx
						invoke lstrcpyn,addr buff,[edx].frbWordStruct.lpAddress,ecx
						invoke atodw,addr buff
						mov frame_cnt,eax
					.endif
				.endif
			popad
			pushad
				invoke szCmpi,addr buff,CADD("FRAME"),5
				.if eax==0
					mov ecx,l_cnt
					inc ecx
					mov data_off,ecx
					invoke GetWord,hFile,l_cnt,3
					.if eax!=-1
						invoke StrToFloat,[edx].frbWordStruct.lpAddress,addr fr_time
					.endif
				.endif
			popad
		popad
	end_check:
	inc ecx
	cmp ecx,counter
	jl loop_each_lines
	
	
	invoke dw2a,frame_cnt,addr buff
	;invoke MessageBox,0,addr buff,0,0
	
	mov ecx,frame_cnt
	shl ecx,2
	invoke mAlloc,ecx
	mov lpframe,eax
	mov ecx,node_cnt
	
	xor ecx,ecx
	loop_alloc:
	pushad
		push ecx
			mov ecx,node_cnt
			shl ecx,2
			invoke mAlloc,ecx
		pop edx
		mov ecx,lpframe
		mov [ecx+edx*4],eax
	popad
	inc ecx
	cmp ecx,frame_cnt
	jl loop_alloc
	
	xor ecx,ecx
	mov offset_cnt,ecx
	mov channel_cnt,ecx
	loop_get_data:
		pushad
			inc ecx
			invoke UM_Word_Count,hFile,ecx
			mov w_cnt,eax
		popad
		cmp w_cnt,0
		jz get_data_end
		cmp w_cnt,-1
		jz get_data_end
		pushad
			invoke memfill,addr buff,1024,0
		popad
		pushad
			inc ecx
			mov l_cnt,ecx
			invoke GetWord,hFile,ecx,1
			pushad
				mov ecx,[edx].frbWordStruct.nSize
				inc ecx
				invoke lstrcpyn,addr buff,[edx].frbWordStruct.lpAddress,ecx
				invoke szCmpi,addr buff,CADD("OFFSET"),6
				.if eax==0
					mov ecx,sizeof fObject
					invoke mAlloc,ecx
					mov obj_data,eax
					invoke GetWord,hFile,l_cnt,2
					.if eax!=-1
						invoke StrToFloat,[edx].frbWordStruct.lpAddress,addr fr
					.else
						invoke MessageBox,0,CADD("Failed retrieving Offset X"),0,0
					.endif
					mov eax,obj_data
					fld fr
					fstp [eax].fObject.OffsetX
					
					invoke GetWord,hFile,l_cnt,3
					.if eax!=-1
						invoke StrToFloat,[edx].frbWordStruct.lpAddress,addr fr
					.else
						invoke MessageBox,0,CADD("Failed retrieving Offset Y"),0,0
					.endif
					mov eax,obj_data
					fld fr
					fstp [eax].fObject.OffsetY
					
					invoke GetWord,hFile,l_cnt,4
					.if eax!=-1
						invoke StrToFloat,[edx].frbWordStruct.lpAddress,addr fr
					.else
						invoke MessageBox,0,CADD("Failed retrieving Offset Z"),0,0
					.endif
					mov eax,obj_data
					fld fr
					fstp [eax].fObject.OffsetZ
					
					mov eax,lpframe				; Fill frame 1 with offset data
					mov eax,[eax]
					mov ecx,offset_cnt
					mov edx,obj_data
					mov [eax+ecx*4],edx
					
					inc offset_cnt
				.endif
			popad
			pushad
				mov ecx,[edx].frbWordStruct.nSize
				inc ecx
				invoke lstrcpyn,addr buff,[edx].frbWordStruct.lpAddress,ecx
				invoke szCmpi,addr buff,CADD("CHANNELS"),8
				.if eax==0
					invoke GetWord,hFile,l_cnt,2
					mov ecx,[edx].frbWordStruct.nSize
					inc ecx
					invoke lstrcpyn,addr buff,[edx].frbWordStruct.lpAddress,ecx
					invoke atodw,addr buff
					push eax
						mov ecx,offset_cnt
						dec ecx
						invoke fBVHGetData,lpframe,0,ecx
					pop ecx
					mov [eax].fObject.nChannel,ecx
					add channel_cnt,ecx
				.endif
			popad
		popad
		
	get_data_end:
	inc ecx
	cmp ecx,counter
	jl loop_get_data
	
	mov eax,node_cnt
	shl eax,2
	invoke mAlloc,eax
	mov node_st,eax
	xor eax,eax
	mov nodest_cnt,eax
	
	xor ecx,ecx
	mov offset_cnt,ecx
	mov channel_cnt,ecx
	loop_get_name:
		pushad
			inc ecx
			invoke UM_Word_Count,hFile,ecx
			mov w_cnt,eax
		popad
		pushad
			inc ecx
			invoke TextFromFile,ecx,hFile
			inc eax
			.if eax<1024
				invoke lstrcpyn,addr buff,edx,eax
				invoke szWcnt,addr buff,CADD("}")
				.if eax!=0
					dec nodest_cnt
				.endif
			.endif			
		popad
		
		cmp w_cnt,0
		jz get_name_end
		cmp w_cnt,-1
		jz get_name_end
		pushad
			invoke memfill,addr buff,1024,0
		popad
		pushad
			inc ecx
			mov l_cnt,ecx
			invoke GetWord,hFile,ecx,1
			pushad
				mov ecx,[edx].frbWordStruct.nSize
				inc ecx
				invoke lstrcpyn,addr buff,[edx].frbWordStruct.lpAddress,ecx
				invoke szCmpi,addr buff,CADD("ROOT"),4
				.if eax==0
					invoke GetWord,hFile,l_cnt,2
					.if eax!=-1
						pushad
							invoke memfill,addr buff,1024,0
						popad
						push edx
						invoke mAlloc,[edx].frbWordStruct.nSize
						pop edx
						push eax
							mov ecx,[edx].frbWordStruct.nSize
							inc ecx
							push ecx
							invoke lstrcpyn,addr buff,[edx].frbWordStruct.lpAddress,ecx
							pop ecx
							invoke fBVHGetData,lpframe,0,offset_cnt
						pop ecx
						pushad
							invoke lstrcat,ecx,addr buff
						popad
						mov [eax].fObject.lpName,ecx
						inc offset_cnt
					.endif
					mov eax,nodest_cnt
					.if eax==0
						inc nodest_cnt
						mov eax,nodest_cnt
						dec eax
						mov edx,node_st
						mov ecx,offset_cnt
						dec ecx
						mov [edx+eax*4],ecx
						invoke fBVHGetData,lpframe,0,ecx
						push 0
						pop [eax].fObject.nParent
					.endif
				.endif
			popad
			pushad
				mov ecx,[edx].frbWordStruct.nSize
				inc ecx
				invoke lstrcpyn,addr buff,[edx].frbWordStruct.lpAddress,ecx
				invoke szCmpi,addr buff,CADD("JOINT"),5
				.if eax==0
					invoke GetWord,hFile,l_cnt,2
					.if eax!=-1
						pushad
							invoke memfill,addr buff,1024,0
						popad
						push edx
						invoke mAlloc,[edx].frbWordStruct.nSize
						pop edx
						push eax
							mov ecx,[edx].frbWordStruct.nSize
							inc ecx
							push ecx
							invoke lstrcpyn,addr buff,[edx].frbWordStruct.lpAddress,ecx
							pop ecx
							invoke fBVHGetData,lpframe,0,offset_cnt
						pop ecx
						pushad
							invoke lstrcat,ecx,addr buff
						popad
						mov [eax].fObject.lpName,ecx
						inc offset_cnt
					.endif
					mov eax,nodest_cnt
					dec eax
					mov edx,node_st
					mov eax,[edx+eax*4]
					push eax
						mov ecx,offset_cnt
						dec ecx
						invoke fBVHGetData,lpframe,0,ecx
					pop [eax].fObject.nParent
					inc nodest_cnt
					mov eax,nodest_cnt
					dec eax
					mov edx,node_st
					mov ecx,offset_cnt
					dec ecx
					mov [edx+eax*4],ecx
					
				;	mov eax,nodest_cnt
				;	dec eax
				;	mov edx,node_st
				;	mov ecx,offset_cnt
				;	dec ecx
				;	mov [edx+eax*4],ecx
					
				.endif
			popad
			pushad
				mov ecx,[edx].frbWordStruct.nSize
				inc ecx
				invoke lstrcpyn,addr buff,[edx].frbWordStruct.lpAddress,ecx
				invoke szCmpi,addr buff,CADD("END"),3
				.if eax==0
					invoke GetWord,hFile,l_cnt,2
					.if eax!=-1
						pushad
							invoke memfill,addr buff,1024,0
						popad
						push edx
						invoke mAlloc,[edx].frbWordStruct.nSize
						pop edx
						push eax
							mov ecx,[edx].frbWordStruct.nSize
							inc ecx
							push ecx
							invoke lstrcpyn,addr buff,[edx].frbWordStruct.lpAddress,ecx
							pop ecx
							invoke fBVHGetData,lpframe,0,offset_cnt
						pop ecx
						pushad
							invoke lstrcat,ecx,addr buff
						popad
						mov [eax].fObject.lpName,ecx
						inc offset_cnt
					.endif
					mov eax,nodest_cnt
					dec eax
					mov edx,node_st
					mov eax,[edx+eax*4]
					push eax
						mov ecx,offset_cnt
						dec ecx
						invoke fBVHGetData,lpframe,0,ecx
					pop [eax].fObject.nParent
					inc nodest_cnt
					mov eax,nodest_cnt
					dec eax
					mov edx,node_st
					mov ecx,offset_cnt
					dec ecx
					mov [edx+eax*4],ecx
				.endif
			popad
		popad
	get_name_end:
	inc ecx
	cmp ecx,counter
	jl loop_get_name
	
	invoke GlobalFree,node_st
;	invoke ltoa,nodest_cnt,addr buff
;	invoke MessageBox,0,addr buff,0,0 
	
	xor ecx,ecx
	mov offset_cnt,ecx
	mov channel_cnt,ecx
	loop_get_frame_data:
		pushad
			inc ecx
			invoke UM_Word_Count,hFile,ecx
			mov w_cnt,eax
		popad
		cmp w_cnt,0
		jz loop_get_frame_data_end
		cmp w_cnt,-1
		jz loop_get_frame_data_end
		pushad
			invoke memfill,addr buff,1024,0
		popad
		pushad
			inc ecx
			mov l_cnt,ecx
			invoke GetWord,hFile,ecx,1
			pushad
				mov ecx,[edx].frbWordStruct.nSize
				inc ecx
				invoke lstrcpyn,addr buff,[edx].frbWordStruct.lpAddress,ecx
				invoke szCmpi,addr buff,CADD("ROOT"),4
				.if eax==0
					mov ecx,l_cnt
					add ecx,3
					invoke GetWord,hFile,ecx,1
					mov ecx,[edx].frbWordStruct.nSize
					inc ecx
					invoke lstrcpyn,addr buff,[edx].frbWordStruct.lpAddress,ecx
					invoke szCmpi,addr buff,CADD("CHANNELS"),8
					.if eax==0
						invoke fBVHGetData,lpframe,0,offset_cnt
						mov eax,[eax].fObject.nChannel
						.if eax==3
							mov ecx,l_cnt
							add ecx,3
							invoke fBVHFillStructName3,hFile,ecx,lpframe,offset_cnt
						.elseif eax==6
							mov ecx,l_cnt
							add ecx,3
							invoke fBVHFillStructName6,hFile,ecx,lpframe,offset_cnt
						.else
							invoke MessageBox,0,CADD("Unknown Format"),0,0
						.endif
					.else
						invoke MessageBox,0,CADD("File is broken or unknown format"),0,0
					.endif
					inc offset_cnt
				.endif
			popad
			pushad
				mov ecx,[edx].frbWordStruct.nSize
				inc ecx
				invoke lstrcpyn,addr buff,[edx].frbWordStruct.lpAddress,ecx
				invoke szCmpi,addr buff,CADD("JOINT"),5
				.if eax==0
					mov ecx,l_cnt
					add ecx,3
					invoke GetWord,hFile,ecx,1
					mov ecx,[edx].frbWordStruct.nSize
					inc ecx
					invoke lstrcpyn,addr buff,[edx].frbWordStruct.lpAddress,ecx
					invoke szCmpi,addr buff,CADD("CHANNELS"),8
					.if eax==0
						invoke fBVHGetData,lpframe,0,offset_cnt
						mov eax,[eax].fObject.nChannel
						.if eax==3
							mov ecx,l_cnt
							add ecx,3
							invoke fBVHFillStructName3,hFile,ecx,lpframe,offset_cnt
						.elseif eax==6
							mov ecx,l_cnt
							add ecx,3
							invoke fBVHFillStructName6,hFile,ecx,lpframe,offset_cnt
						.else
							invoke MessageBox,0,CADD("Unknown Format"),0,0
						.endif
					.else
						invoke MessageBox,0,CADD("File is broken or unknown format"),0,0
					.endif
					inc offset_cnt
				.endif
			popad
			pushad
				mov ecx,[edx].frbWordStruct.nSize
				inc ecx
				invoke lstrcpyn,addr buff,[edx].frbWordStruct.lpAddress,ecx
				invoke szCmpi,addr buff,CADD("END"),3
				.if eax==0
					
					inc offset_cnt
				.endif
			popad
		popad
	loop_get_frame_data_end:
	inc ecx
	cmp ecx,counter
	jl loop_get_frame_data
	
	
	xor edx,edx
	inc edx
	mov channel_cnt,edx
	xor ecx,ecx
	loop_object:
		pushad
			mov t_data,ecx
			xor ecx,ecx
			loop_each_frame:
			pushad
				add ecx,data_off
				mov m_data,ecx
				sub ecx,data_off
				invoke fBVHGetData,lpframe,ecx,t_data
				.if eax==0
					invoke fBVHGetData,lpframe,0,t_data
					
					push eax
					invoke mAlloc,sizeof fObject
					pop edx
					
					push [edx].fObject.nChannel
					pop [eax].fObject.nChannel
					push [edx].fObject.lpChannel1
					pop [eax].fObject.lpChannel1
					push [edx].fObject.lpChannel2
					pop [eax].fObject.lpChannel2
					push [edx].fObject.lpChannel3
					pop [eax].fObject.lpChannel3
					push [edx].fObject.lpChannel4
					pop [eax].fObject.lpChannel4
					push [edx].fObject.lpChannel5
					pop [eax].fObject.lpChannel5
					push [edx].fObject.lpChannel6
					pop [eax].fObject.lpChannel6
					
					push [edx].fObject.lpName
					pop [eax].fObject.lpName
					
					push [edx].fObject.nParent
					pop [eax].fObject.nParent
					
					.if [edx].fObject.nChannel==3
						push [edx].fObject.OffsetX
						pop [eax].fObject.OffsetX
						push [edx].fObject.OffsetY
						pop [eax].fObject.OffsetY
						push [edx].fObject.OffsetZ
						pop [eax].fObject.OffsetZ
					.endif
					
					mov ecx,m_data
					sub ecx,data_off
					push eax
					invoke fBVHSetData,lpframe,ecx,t_data,eax
					pop eax
				.endif
				
				.if [eax].fObject.nChannel==6
					push channel_cnt
					push eax
						invoke GetWord,hFile,m_data,channel_cnt
						invoke StrToFloat,[edx].frbWordStruct.lpAddress,addr fr
					pop eax
					mov edx,[eax].fObject.lpChannel1
					movzx edx,word ptr[edx]
					mov ecx,eax
					push eax
					invoke fBVHLoadValue,edx,ecx,addr fr
					pop eax
					inc channel_cnt
					
					push eax
						invoke GetWord,hFile,m_data,channel_cnt
						invoke StrToFloat,[edx].frbWordStruct.lpAddress,addr fr
					pop eax
					mov edx,[eax].fObject.lpChannel2
					movzx edx,word ptr[edx]
					mov ecx,eax
					push eax
					invoke fBVHLoadValue,edx,ecx,addr fr
					pop eax
					inc channel_cnt
					
					push eax
						invoke GetWord,hFile,m_data,channel_cnt
						invoke StrToFloat,[edx].frbWordStruct.lpAddress,addr fr
					pop eax
					mov edx,[eax].fObject.lpChannel3
					movzx edx,word ptr[edx]
					mov ecx,eax
					push eax
					invoke fBVHLoadValue,edx,ecx,addr fr
					pop eax
					inc channel_cnt
					
					push eax
						invoke GetWord,hFile,m_data,channel_cnt
						invoke StrToFloat,[edx].frbWordStruct.lpAddress,addr fr
					pop eax
					mov edx,[eax].fObject.lpChannel4
					movzx edx,word ptr[edx]
					mov ecx,eax
					push eax
					invoke fBVHLoadValue,edx,ecx,addr fr
					pop eax
					inc channel_cnt
					
					push eax
						invoke GetWord,hFile,m_data,channel_cnt
						invoke StrToFloat,[edx].frbWordStruct.lpAddress,addr fr
					pop eax
					mov edx,[eax].fObject.lpChannel5
					movzx edx,word ptr[edx]
					mov ecx,eax
					push eax
					invoke fBVHLoadValue,edx,ecx,addr fr
					pop eax
					inc channel_cnt
					
					push eax
						invoke GetWord,hFile,m_data,channel_cnt
						invoke StrToFloat,[edx].frbWordStruct.lpAddress,addr fr
					pop eax
					mov edx,[eax].fObject.lpChannel6
					movzx edx,word ptr[edx]
					mov ecx,eax
					push eax
					invoke fBVHLoadValue,edx,ecx,addr fr
					pop eax
				;	inc channel_cnt
					
					pop channel_cnt
					mov channel_c,6
				.elseif [eax].fObject.nChannel==3
					push channel_cnt
						push eax
							invoke UM_Word_Count,hFile,m_data
							.if eax<channel_cnt
								mov edx,eax
								invoke dw2a,edx,addr buff 
								invoke MessageBox,0,CADD("Data count is less than the channel"),addr buff,0
							.endif
							
							invoke GetWord,hFile,m_data,channel_cnt
							.if eax==-1
								invoke MessageBox,0,0,0,0
							.else
								;invoke MessageBox,0,0,0,0
							.endif
							invoke StrToFloat,[edx].frbWordStruct.lpAddress,addr fr
						pop eax
						mov edx,[eax].fObject.lpChannel1
						movzx edx,word ptr[edx]
						mov ecx,eax
						invoke fBVHLoadValue,edx,ecx,addr fr
						inc channel_cnt
						
						push eax
							invoke GetWord,hFile,m_data,channel_cnt
							invoke StrToFloat,[edx].frbWordStruct.lpAddress,addr fr
						pop eax
						mov edx,[eax].fObject.lpChannel2
						movzx edx,word ptr[edx]
						mov ecx,eax
						invoke fBVHLoadValue,edx,ecx,addr fr
						inc channel_cnt
						
						push eax
							invoke GetWord,hFile,m_data,channel_cnt
							invoke StrToFloat,[edx].frbWordStruct.lpAddress,addr fr
						pop eax
						mov edx,[eax].fObject.lpChannel3
						movzx edx,word ptr[edx]
						mov ecx,eax
						invoke fBVHLoadValue,edx,ecx,addr fr
						inc channel_cnt
						
					pop channel_cnt
					mov channel_c,3
				.elseif [eax].fObject.nChannel==0
					mov channel_c,0
				.endif
			popad
			inc ecx
			cmp ecx,frame_cnt
			jl loop_each_frame
			
			mov ecx,channel_c
			add channel_cnt,ecx
		popad
	inc ecx
	cmp ecx,node_cnt
	jl loop_object
	
	mov eax,lpfBVH
	push lpframe
	pop [eax].fBVH.lpData
	push node_cnt
	pop [eax].fBVH.nObjCount
	push frame_cnt
	pop [eax].fBVH.nFrameCount
	fld fr_time
	fstp [eax].fBVH.flFrameTime
	
	
	invoke CloseFileFrb,hFile
	mov eax,lpframe
	ret
fBVHReadData endp
